//
// ********************************************************************
// * License and Disclaimer                                           *
// *                                                                  *
// * The  Geant4 software  is  copyright of the Copyright Holders  of *
// * the Geant4 Collaboration.  It is provided  under  the terms  and *
// * conditions of the Geant4 Software License,  included in the file *
// * LICENSE and available at  http://cern.ch/geant4/license .  These *
// * include a list of copyright holders.                             *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.  Please see the license in the file  LICENSE  and URL above *
// * for the full disclaimer and the limitation of liability.         *
// *                                                                  *
// * This  code  implementation is the result of  the  scientific and *
// * technical work of the GEANT4 collaboration.                      *
// * By using,  copying,  modifying or  distributing the software (or *
// * any work based  on the software)  you  agree  to acknowledge its *
// * use  in  resulting  scientific  publications,  and indicate your *
// * acceptance of all terms of the Geant4 Software license.          *
// ********************************************************************
//

#include "MyExDetectorConstruction.hh"
//#include "MyExTrackerSD.hh"
//#include "MyExCalorimeterSD.hh"
//#include "MyExCalorimeterROGeometry.hh"
//#include "MyExMuonSD.hh"
//#include "MyExTrackerParametrisation.hh"
//#include "MyExCalorimeterParametrisation.hh"
//#include "MyExField.hh"

#include "G4Material.hh"
#include "G4MaterialTable.hh"
#include "G4Element.hh"
#include "G4ElementTable.hh"
#include "G4Box.hh"
//#include "G4Tubs.hh"
#include "G4LogicalVolume.hh"
#include "G4ThreeVector.hh"
#include "G4PVPlacement.hh"
//#include "G4PVParameterised.hh"
//#include "G4Transform3D.hh"
//#include "G4RotationMatrix.hh"
//#include "G4FieldManager.hh"
//#include "G4TransportationManager.hh"
//#include "G4SDManager.hh"
#include "G4VisAttributes.hh"
#include "G4Colour.hh"

/*
MyExDetectorConstruction::MyExDetectorConstruction()
{

  #include "MyExDetectorParameterDef.icc"
    DefineMaterials();

    }
*/

MyExDetectorConstruction::~MyExDetectorConstruction()
{
  delete Gold;
  delete Air;

  delete O;
  delete N;
}

void MyExDetectorConstruction::DefineMaterials()
{
  //-------------------------------------------------------------------------
  // Materials
  //-------------------------------------------------------------------------

  G4double a, z, density;
  G4int nel;


  N = new G4Element("Nitrogen", "N", z=7., a= 14.01*g/mole);
  O = new G4Element("Oxygen",   "O", z=8., a= 16.00*g/mole);
  //Au = new G4Element("Gold", "Au", z=79., a= 196.97*g/mole);


  Air = new G4Material("Air", density= 1.29*mg/cm3, nel=2);
  Air->AddElement(N, 70.*perCent);
  Air->AddElement(O, 30.*perCent);

  Gold = new G4Material("Gold", z=79., a=196.97*g/mole, density= 19.3*g/cm3);
  
  
}

G4VPhysicalVolume* MyExDetectorConstruction::Construct()
{

  //-------------------------------------------------------------------------
  // Detector geometry
  //-------------------------------------------------------------------------

  //------------------------------ experimental hall
  G4Box * experimentalHall_box
    = new G4Box("expHall_b",600*cm,600*cm,600*cm);
  G4LogicalVolume * experimentalHall_log
    = new G4LogicalVolume(experimentalHall_box,Air,"expHall_L",0,0,0);
  G4VPhysicalVolume * experimentalHall_phys
    = new G4PVPlacement(0,G4ThreeVector(),experimentalHall_log,"expHall_P",
                        0,false,0);
  experimentalHall_log->SetVisAttributes(G4VisAttributes::GetInvisible());

  //------------------------------ gold mass
  G4Box * goldmass_box
    = new G4Box("goldmass_b",200*cm,200*cm,200*cm);
  G4LogicalVolume * goldmass_log
    = new G4LogicalVolume(goldmass_box,Gold,"goldmass_L",0,0,0);
  G4VPhysicalVolume * goldmass_phys
    =new G4PVPlacement(0,G4ThreeVector(),goldmass_log,"goldmass_P",
		       0,false,0);
  G4VisAttributes* goldmass_logVisAtt
    = new G4VisAttributes(G4Colour(1.0,0.0,1.0));
  goldmass_log->SetVisAttributes(goldmass_logVisAtt);


  //------------------------------------------------------------------
  // Sensitive Detector
  //------------------------------------------------------------------

  /*  G4SDManager* SDman = G4SDManager::GetSDMpointer();

  G4String trackerSDname = "/mydet/tracker";
  MyExTrackerSD * trackerSD = new MyExTrackerSD(trackerSDname);
  SDman->AddNewDetector(trackerSD);
  trackerLayer_log->SetSensitiveDetector(trackerSD);

  G4String calorimeterSDname = "/mydet/calorimeter";
  MyExCalorimeterSD * calorimeterSD = new MyExCalorimeterSD(calorimeterSDname);
  G4String ROgeometryName = "CalorimeterROGeom";
  G4VReadOutGeometry* calRO = new MyExCalorimeterROGeometry(ROgeometryName);
  calRO->BuildROGeometry();
  calRO->SetName(ROgeometryName);
  calorimeterSD->SetROgeometry(calRO);
  SDman->AddNewDetector(calorimeterSD);
  calorimeter_log->SetSensitiveDetector(calorimeterSD);

  G4String muonSDname = "/mydet/muon";
  MyExMuonSD * muonSD = new MyExMuonSD(muonSDname);
  SDman->AddNewDetector(muonSD);
  muoncounter_log->SetSensitiveDetector(muonSD);
  */
  //------------------------------------------------------------------
  // Digitizer modules
  //------------------------------------------------------------------
  
  return goldmass_phys;
  return experimentalHall_phys;
   
}

